#ifndef LIBMENU_MENU_H
#define LIBMENU_MENU_H

#include <stdbool.h>
#include <pspctrl.h>

#include "color.h"



#ifdef __cplusplus
extern "C" {
#endif


#define MENU_SUSPEND			true
#define MENU_RESUME				false

#define	MENU_VIEW_ALL			false
#define	MENU_VIEW_Active		true

#define PB_TRANSPARENT			0

#define	POS_X_MAX				59
#define	POS_Y_MAX				33



typedef enum
{
	MenuContainer,
	RadioButton,
	ToggleButton,
	CheckBox,
	Spacer,
	SelectBox,
	UpDownCtrl,
	TriggerButton,
	RadioButtonGroup
} MenuItemType;




typedef enum
{
	Menu_None = 0,
	Menu_Show,
	Menu_Up,
	Menu_Down,
	Menu_Left,
	Menu_Right,
	Menu_Select,
	Menu_Back,
	Menu_Close
} MenuResult;


typedef enum
{
	SET_OPT_NONE,
	SET_OPT_LIST,
	SET_OPT_FUNC,
} optType;



typedef struct MenuItem
{
	struct MenuItem			*Parent;		//ACe̐e ( NULL = Root )
	struct MenuItem			*Next;			//ACe̎
	struct MenuItem			*Prev;			//ACȇO
	struct MenuItem			*Children;		//ACe̎q
	
	
	const char				*Name;			//ACei\j
	MenuItemType			Type;			//ACẽ^Cv
	int						actionID;		//ACeIꂽ肵ɁAhandleMenu̕ԋpl֑actionID
	int						Data;			//ACel
	
	bool					Visible;		//ACẻ( ture ,false )
	bool					Disable;		//ACe̗LE 
	
	
	//ANeBũACe`F
	//w肪Ȃ Context ̒ʏF
	
	struct
	{
		u32 				Font;			//tHg
		u32 				Back;			//wi
		u32					Line;			//
	}Color;
	
	
	union
	{
		//WI{^p
		struct MenuItem		*RB_Group;		//O[vւ̃|C^[
		
		//WI{^EO[vp
		struct MenuItem		*Group_Sel;		//I𒆃ACeւ̃|C^[
		
		//Rei[p
		struct
		{
			bool			IsOpen;			//J
			struct MenuItem	*Disp;			//֘Atďԕ\ACeւ̃|C^[
		}CNT;
		
		//`FbN{bNXp
		bool				CB_Checked; 	//I
		
		//Xg{bNXp
		struct
		{
			const char		**List;			//Xgւ̃|C^[
			int				Index;			//I𒆂index
		}SB;
		
		//Abv_Ep
		struct
		{
			float			Now;			//ݒn
			float			Step;			//Stepl (+/-)
			float			Min;			//ŏl
			float			Max;			//ől
			bool			type;			//\^Cv ( true =  , false =  )
		}UD;
		
	}Ctrl;
	
} MenuItem;


typedef struct MenuAction
{
	MenuResult	Action;
	MenuItem		*Item;
} MenuParams;


typedef struct
{
	struct
	{
		//j[pACe瓮Imۂꍇɐݒ
		void* (*malloc_p)(SceSize size) ;
		void  (*free_p) (void *ptr) ;
	}func;
	
	struct
	{
		//j[pACemۂX^bN̕ϐɂꍇɐݒ
		MenuItem *val;
		int size;
	} list;
	
	//j[pACe̊mە@
	optType type;	//SET_OPT_LIST => X^bN̕ϐASET_OPT_FUNC => Im
	
	int count;
	
} libmOpt;



typedef struct MenuContext
{
	//j[pKey
	struct
	{
		u32 				Show;			//\
		u32					Back;			//A߂
		u32					Select;			//I
		u32					Up;				//ֈړ
		u32					Down;			//ֈړ
		u32					Left;			//ֈړ
		u32					Right;			//Eֈړ
	}HotKey;
	
	struct
	{
		u32					Active_Font;	//ANeBu ACẽtHgF
		u32					Active_Back;	//ANeBu ACe̔wiF
		
		u32					Normal_Font;	//ANeBu ACẽtHgF
		u32					Normal_Back;	//ANeBu ACe̔wiF
		
		u32					Disable_Font;	//ȃACẽtHgF
		u32					Disable_Back;	//ȃACe̔wiF
	}Color;
	
	//j[\Ɋւݒ
	struct
	{
		bool				Type;			//j[̃^Cv ( true = ANeBuȍڂ̂ , false = S )
		bool 				StopThread;		//j[\AXbh~邩ǂ
		bool				AutoReturn;		//j[ŏ㕔EŎ^[邩ǂ
		u32					Lines;			//sԁiftHg = 1A0Ɖ`悪Ɂj
	}MenuInfo;
	
	MenuParams				Params;
	
	bool 					IsOpen;			//j[\ǂ(\A\j
	SceCtrlData				LastState;		//Ah~pAOpbhێ
	MenuItem				*Root;			//rootACeւ̃|C^[
	MenuItem				*Active;		//݃ANeBuȃACeւ̃|C^
	
	libmOpt *opt;
	
} MenuContext;




/* MenuSetActiveItem
    j[ŃANeBuȃACeݒ肷
    
    @param: MenuContext *context
    Ώۂ̃j[ReLXg
    
    @param: MenuItem *item
    ANeBuw肷ACew
 */
void MenuSetActiveItem( MenuContext *Context ,MenuItem *item );

/* MenuGetActiveItem
    j[ŃANeBuȃACe擾
    
    @param: MenuContext *context
    Ώۂ̃j[ ReLXg
    
    @return: ݃ANeBuȃACe
 */
MenuItem* MenuGetActiveItem(MenuContext* Context);



/* MenuIsOpen
    j[̕\/\ Ԃ擾
    
    @param: MenuContext *context
    Ώۂ̃j[ ReLXg
    
    @return : \/\̏
    false = \Atrue = \
 */
bool isMenuOpen(MenuContext* Context);


/* Is_Invalid_Item
    ACeȕ𒲂ׂ
    
    @param: MenuItem *Item
    Ώۂ̃ACe
    
    @return : ACȅ
    false = ACeł͂ȂAtrue = ACe
 */
bool Is_Invalid_Item(MenuItem *Item);

/* GetPrevItem
    ÕACe
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACeOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* GetPrevItem( MenuItem *Item , bool Invalid_Skip );


/* GetNextItem
    莟̃ACe
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACeOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* GetNextItem( MenuItem *Item , bool Invalid_Skip );



/* GetBottomItem
    猟ĈԍŌɂACe𒲂ׂ
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACeOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* GetBottomItem( MenuItem *Item , bool Invalid_Skip );
	

/* GetTopItem
    猟ĈԍŏɂACe𒲂ׂ
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACeOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* GetTopItem( MenuItem *Item , bool Invalid_Skip );

/* MenuSetOpt
    j[ contextAitem 쐬̃IvVw
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: libmOpt *opt
	
	EACep̃ϐmۂꍇ͂̂悤ȊŐݒ
	opt.type = SET_OPT_LIST;
	opt.list.val	= item_list;			( item_list  MenuItem* ̔z )
	opt.list.size 	= sizeof(item_list);	(opt.list.valŎw肵zTCYj
	MenuSetOpt(&opt);
	
	EACep̃𓮓Imۂꍇ͂̂悤ȊŐݒ
	
	
	opt.type = SET_OPT_FUNC;
	opt.func.malloc_p	= mۊ֐;
	opt.func.free_p		= ֐;
	MenuSetOpt(&opt);
	
    
    @return : ݒoǂ
    false = sAtrue = 
 */

bool MenuSetOpt(MenuContext* Context , libmOpt *opt );




/* createMenuContext
    j[ ReLXg쐬
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @return: 쐬j[ReLXg
    
    쐬ɐƈȉ̒llƂĎݒ肳
    
	context->HotKey.Show			= PSP_CTRL_NOTE ;
	context->HotKey.Back			= PSP_CTRL_CIRCLE;
	context->HotKey.Select			= PSP_CTRL_CROSS;
	context->HotKey.Up				= PSP_CTRL_UP;
	context->HotKey.Down			= PSP_CTRL_DOWN;
	context->HotKey.Left			= PSP_CTRL_LEFT;
	context->HotKey.Right			= PSP_CTRL_RIGHT;
	
	context->MenuInfo.StopThread	= false;
	
	context->MenuInfo.Type			= false;
	
	context->MenuInfo.AutoReturn	= true;
	
	context->Color.Active_Font		= GREEN;
	context->Color.Normal_Font		= WHITE;
	
	context->Color.Active_Back		= BLACK;
	context->Color.Normal_Back		= Invalid;
	
	context->Color.Disable_Font		= GRAY;
	context->Color.Disable_Back		= Invalid;
	
	context->MenuInfo.Lines		 	= 1;
 */
MenuContext* createMenuContext(libmOpt *opt);

/* createMenuContext
    j[ ReLXg폜ij
    
    @param: MenuContext* Context
    폜郁j[ReLXg
    
    MenuSetOptŃImۂݒ̏ꍇ̂݃
    
 */
void removeMenuContext(MenuContext* Context);

/*  addMenuItem
    j[ ReLXgɃACeǉ
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: MenuItem* Parent
    ACeǉΏۂ̐e(ACej
	
    @param: MenuItem* Item
    ǉACe
    
    @param: u32 font_color
    ǉACẽtHgF
    0 w肷ƕ`悵Ȃ
    
    @param: u32 back_color
    ǉACe̔wiF
    0 w肷ƕ`悵Ȃ
    
    @param: int actionID
    ACeIꂽ肵ɁA
    handleMenu̕ԋpl֑actionID
    
    @param: int Data
    ǉACef[^(int)
    
    @return: 쐬ꂽACe
 */
MenuItem* addMenuItem(MenuContext* Context, MenuItem* Parent, MenuItem* Item,u32 font_color,u32 back_color, int actionID, int Data);

/* createMenuContext
    ACe폜ij
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: MenuItem* Item
    Ώۂ̃ACe
    
    MenuSetOptŃImۂݒ̏ꍇ̂݃
    @
    @ΏۂRei[ꍇ́A
    @ɂSACe폜
 */
void removeMenuItem( MenuContext *context , MenuItem* Item );

/* handleMenu
    j[̓擾i`͂Ȃj
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: SceCtrlData* Input
    Key( SceCtrlData )
    
    @return: MenuParams (IꂽACeAj[̏ԂȂǁj
 */

MenuParams* handleMenu(MenuContext* Context, SceCtrlData* Input);

/*  renderMenu
    VRAMփj[`悷
    
    @param: MenuContext* Context
    Ώۂ̃j[ context
    
    @param:  int PosX
    j[̕\ʒu X
    
    @param: int PosY
    j[̕\ʒu Y
    
    
    j[\ɑXbh~LɂĂꍇ
    \(Xbh~) HOME{^ 
    Q[I\ɂ邽߂ɎőXbhĊJ + j[
 */
void renderMenu(MenuContext* Context,int PosX,int PosY);




/*  createMenuContainer
    ACe쐬ij[Rei[j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    Rei
    
    @return : 쐬ꂽACe
 */
MenuItem* createMenuContainer(libmOpt *opt ,const char* Name);

/*  createRadioButton
    ACe쐬iWI{^j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    WI{^
    
    @param: bool State
    I
    
    @param: MenuItem * Group
  @֘At郉WI{^ O[v
  @createRadioButtonGroupō쐬
  @wK{
  @
	@return : 쐬ꂽACe
	
	addMenuItemŎۂɒǉ鎞́A
	Parent(e)Rei[ ܂ NULLłȂƖ
 */
MenuItem* createRadioButton(libmOpt *opt ,const char* Name, bool State,MenuItem * Group);

/*  createRadioButtonGroup
    ACe쐬iWI{^ O[v)
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @return : 쐬ꂽACe
 */
MenuItem* createRadioButtonGroup(libmOpt *opt);



/*  createCheckBox
    ACe쐬i`FbN{bNXj
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    `FbN{bNX
    
    @param: bool State
    I
    
	@return : 쐬ꂽACe
 */
MenuItem* createCheckBox(libmOpt *opt ,const char* Name, bool State);

/*  createSelectBox
    ACe쐬i`FbN{bNXj
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    ZNg{bNX
    
    @param: const char *List[]
    ZNg{bNXɕ\ACeXg
    const char *̔zAŌNULLKv
    
    @param: int Selected
    XgŏɑIς݂Ƃʒu
    
    @return : 쐬ꂽACe
 */
MenuItem* createSelectBox(libmOpt *opt ,const char* Name, const char *List[],int Selected);

/*  createUpDownCtrl
    ACe쐬iAbv_ERg[j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    Abv_ERg[
    
    @param: float Now
    ݒl
    
    @param: float Step
    l
    
    @param: float Min
    ŏl
    
    @param: float Max
    ől
    
    @param: bool type
    false = `掞Ɍݒl_\ ( 00.00 ̂悤Ȋj
    true = `掞Ɍݒl𐮐\
    
    @return : 쐬ꂽACe
 */
MenuItem* createUpDownCtrl(libmOpt *opt ,const char* Name,float Now,float Step,float Min, float Max,bool type);

/*  createSpacer
    ACe쐬iXy[T[j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    Xy[T[
    
    @return : 쐬ꂽACe
 */
MenuItem* createSpacer(libmOpt *opt ,const char* Name);

/*  createTriggerButton
    ACe쐬igK[{^)
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
	@param: const char* Name
    gK[{^
    
    @return : 쐬ꂽACe
 */
MenuItem* createTriggerButton(libmOpt *opt ,const char* Name);





/*  dumpOtherThreads
	j[\ɑXbh~Lɂ
	dvȃXbh܂Ȃ悤ɈSXg
    
    @return: Dumpoǂ
    
    vOCNɏo邾iK
    dumpOtherThreads();@邱
    
    j[\ɑXbh~ȂΕKvȂ
    
    */
bool dumpOtherThreads();

/*  setThreadsStat
	Xbh~
    
    @params : bool stat
    MENU_SUSPEND = ~
    MENU_RESUME = ĊJ
    
    @return : v삪soǂ
    
    
    OɁ@dumpOtherThreads();@ĂȂƋ@\Ȃ
    
    */
bool setThreadsStat( bool stat );

/*  getThreadsStat
	Xbh̏Ԃ擾
    
   	@return : true = ~AMENU_RESUME = 쒆
    
    OɁ@dumpOtherThreads();@ĂȂƋ@\Ȃ
    
    */
bool getThreadsStat();


/*  setMenuBuffer
    ݂̃fBXvC̏Ԃɍ킹
    j[`揀
    
    @param: int sync
    Ώ
    
	PSP_DISPLAY_SETBUF_IMMEDIATE
	PSP_DISPLAY_SETBUF_NEXTFRAME
	̂ǂ炩w
    
    @return: Menu`Ώۂ VRAM AhX
 */
bool  setMenuBuffers( int sync );

/*  getMenuBuffer
    renderMenu ŕ`悵ĂVRAM AhX̎擾 
    
    @return: Menu`Ώۂ VRAM AhX
 */
void* getMenuBuffers();

/*  swapMenuBuffers
    renderMenu ŕ`Ɏgobt@[̕ύX
	
    @return: Menu`Ώۂ VRAM AhX
    
	j[\ɃXbh~悤ɐݒ肵ꍇ
	gƃ_uobt@Ô悤ȂƂo邪
	͓KȂ̂ŕςȓ邩Ȃ
 */
void swapMenuBuffers( int bufsync );

/*  clearMenuBuffer
    renderMenu ŕ`Ɏgobt@[NAiFj
	
 */
void clearMenuBuffers();

/*  libmSetBlend
    At@uh̗LA ݒ肷
    
    @param: bool state
    false = Atrue = L
    
    Xbh~߂ăj[\Ă鎞
    ɂ
 */
void libmSetBlend( bool state );

/*  libmGetBlend
    At@uh̗LA Ԃ擾
    
    @return: At@uhLA 
 */
bool libmGetBlend();




/*  libmPrint
	
	libmenu̓tHgg
	`悷
	
	@params : int x
	\ʒu X
	
	@params : int y
	\ʒu Y
	
	@params : unsigned int fg
	tHgF
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF
	0 ƕ`悵Ȃ
	
	@params : const char *str
    `Ώ 
    
    @return: `悵
 */
int libmPrint( int x, int y, unsigned int fg, unsigned int bg, const char *str );


/*  libmPrintf
	
	libmenu̓tHgg
	t `悷
	
	@params : int x
	\ʒu X
	
	@params : int y
	\ʒu Y
	
	@params : unsigned int fg
	tHgF
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF
	0 ƕ`悵Ȃ
	
	@params : format, ...
    `Ώ t 
    
    @return: `悵
 */
int libmPrintf( int x, int y, unsigned int fg, unsigned int bg, const char *format, ... );


#ifdef __cplusplus
}
#endif

#endif
