#include <pspkernel.h>
#include <pspsdk.h>
#include <pspctrl.h>

#include <pspdisplay.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "libmenu.h"
#include "memory.h"

#define	ITEM_COUNT	66

PSP_MODULE_INFO("MenuTest", PSP_MODULE_KERNEL, 1, 1);



static MenuItem *AlphaAFA,*AlphaABA,*AlphaNFA,*AlphaNBA,*sync_trigger;




enum
{
	NoAction,
	TS_Change,
	ReturnChange,
	TypeChange,
	ColorChange,
	LinesChange,
	AlphaChange,
	D_Alpha,
	DELAYChange,
	Trigger_Push
};



enum
{
	ActiveF,
	ActiveFA,
	ActiveB,
	ActiveBA,
	NormalF,
	NormalFA,
	NormalB,
	NormalBA
};

const char *Movie_Test[] =
{
	"_CEn[h",
	"A}Qh",
	"}gbNX",
	"GCA",
	"S[XgEoX^[Y",
	NULL
};
		
const char *Food_Test[] =
{
	"[",
	"g",
	"₵",
	"Hp",
	"",
	"L`",
	"i",
	NULL
};
		
const char *PC_Test[] =
{
	"j^[",
	"P[X",
	"n[hEfBXN",
	"",
	"}U[E{[h",
	"}EX",
	"CPU",
	"OtBbNEJ[h",
	"v^[",
	NULL
};
		
const char *TypeList[] =
{
	"j[S",
	"ANeBuȍڂ̂",
	NULL
};
		
const char *ColorList[] =
{
	"Ȃ",
	"BLACK",
	"BLUE",
	"RED",
	"GREEN",
	"DARKBLUE",
	"LIGHTBLUE",
	"BROWN",
	"PINK",
	"DARKGREEN",
	"YELLOGREEN",
	"PURPLE",
	"ORANGE",
	"LEMON",
	"YELLOW",
	"SKYBLUE",
	"PEARLORANGE",
	"GRAY",
	"SILVER",
	"GOLD",
	"WHITE",
	NULL
};




u32 GetColor(int index)
{
 	u32 color;
 	
 	switch(index)
	{
		case 1:
			color = BLACK;
			break;
		
		case 2:
			color = BLUE;
			break;
		
		case 3:
			color = RED;
			break;
		
		case 4:
			color = GREEN;
			break;
			
		case 5:
			color = DARKBLUE;
			break;
			
		case 6:
			color = LIGHTBLUE;
			break;
			
		case 7:
			color = BROWN;
			break;
			
		case 8:
			color = PINK;
			break;
		
		case 9:
			color = DARKGREEN;
			break;
			
		case 10:
			color = YELLOGREEN;
			break;
			
		case 11:
			color = PURPLE;
			break;
			
		case 12:
			color = ORANGE;
			break;
			
		case 13:
			color = LEMON;
			break;
			
		case 14:
			color = YELLOW;
			break;
			
		case 15:
			color = SKYBLUE;
			break;
			
		case 16:
			color = PEARLORANGE;
			break;
			
		case 17:
			color = GRAY;
			break;
			
		case 18:
			color = SILVER;
			break;
			
		case 19:
			color = GOLD;
			break;
		
		case 20:
			color = WHITE;
			break;
			
		default:
			color = 0;
	}
	
	return color;
}

MenuContext *Context = NULL;
libmOpt opt;

void MenuCreate()
{
	memset(&opt,0,sizeof(opt));
	opt.type			= SET_OPT_FUNC;
	opt.func.malloc_p	= memoryAlloc;
	opt.func.free_p		= memoryFree;
	
	Context = createMenuContext(&opt);
	
	if( !Context ) return;
	
	//j[ ACe瓮Imۂ悤ɐݒ
	MenuSetOpt(Context,&opt);
	
	
	//j[p̊ePadݒ
		
	//\ + & -
	Context->HotKey.Show				= PSP_CTRL_VOLUP | PSP_CTRL_VOLDOWN;
	//߂ 
	Context->HotKey.Back				= PSP_CTRL_TRIANGLE;
	//I ~
	Context->HotKey.Select			= PSP_CTRL_CROSS;
	// 
	Context->HotKey.Up				= PSP_CTRL_UP;
	// 
	Context->HotKey.Down				= PSP_CTRL_DOWN;
	// 
	Context->HotKey.Left				= PSP_CTRL_LEFT;
	//E
	Context->HotKey.Right			= PSP_CTRL_RIGHT;
		
		
	//j[\ɑXbh~Ȃ
	Context->MenuInfo.StopThread		= false;
	//j[^Cv́uS̕\v
	Context->MenuInfo.Type 			= false;
	//ACeŏ㕔E֗玩Ń^[
	Context->MenuInfo.AutoReturn		= true;
		
	//ANeBuȍڂ̃tHgFAwiF
	Context->Color.Active_Font		= PINK;
	Context->Color.Active_Back		= SetAlpha(BLUE,0x82);
		
	//ANeBuȍڂ̃tHgFAwiF
	Context->Color.Normal_Font		= WHITE;
	Context->Color.Normal_Back		= SetAlpha(GRAY,0x64);
		
	//s
	Context->MenuInfo.Lines			= 1;
	
	
	addMenuItem(Context,NULL,createSpacer(&opt,"j[ Tv"),YELLOGREEN,DARKGREEN,NoAction,0);
	
	addMenuItem(Context,NULL,createTriggerButton(&opt,"gK[{^"),RED,SetAlpha(GREEN,0x66),Trigger_Push,0);
	
	MenuItem* Select_Test = addMenuItem(Context,NULL,createMenuContainer(&opt,"ZNg {bNX"),RED,SetAlpha(GREEN,0x66),NoAction,0);
	{
		MenuItem* msg = addMenuItem(Context,Select_Test,createSpacer(&opt,"Iςݍڂ̎w肪\x89\xC2\x94\x5Cł"),Invalid,Invalid,NoAction,0);
		msg->Color.Line = BLACK;
		
		addMenuItem(Context,Select_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Select_Test,createSpacer(&opt,"Tv 1"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,Select_Test,createSelectBox(&opt,"f:",Movie_Test,2),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Select_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Select_Test,createSpacer(&opt,"Tv 2"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,Select_Test,createSelectBox(&opt,"Hו:",Food_Test,4),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Select_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Select_Test,createSpacer(&opt,"Tv 3"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,Select_Test,createSelectBox(&opt,"PCi:",PC_Test,3),Invalid,Invalid,NoAction,0);
	}
	
	MenuItem* Check_Test = addMenuItem(Context,NULL,createMenuContainer(&opt,"`FbN {bNX"),RED,SetAlpha(GREEN,0x66),NoAction,0);
	{
		addMenuItem(Context,Check_Test,createSpacer(&opt,"Tv 1"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,Check_Test,createCheckBox(&opt,"vO~ODH",false),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Check_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Check_Test,createSpacer(&opt,"Tv 2"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,Check_Test,createCheckBox(&opt,"PS2Ă",false),Invalid,Invalid,NoAction,0);
		addMenuItem(Context,Check_Test,createCheckBox(&opt,"PS3Ă",false),Invalid,Invalid,NoAction,0);
	}
	
	MenuItem* UpDown_Test = addMenuItem(Context,NULL,createMenuContainer(&opt,"AbvE_E Rg["),RED,SetAlpha(GREEN,0x66),NoAction,0);
	{
		MenuItem* msg = addMenuItem(Context,UpDown_Test,createSpacer(&opt,"lAXebvlAŏlAőlݒ"),Invalid,Invalid,NoAction,0);
		msg->Color.Line = BLACK;
		
		addMenuItem(Context,UpDown_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,UpDown_Test,createSpacer(&opt,"Tv 1"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,UpDown_Test,createUpDownCtrl(&opt,"ŃH",20,1,0,150,false),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,UpDown_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,UpDown_Test,createSpacer(&opt,"Tv 2"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,UpDown_Test,createUpDownCtrl(&opt,"RGB(R):",100,5,0,255,true),Invalid,Invalid,NoAction,0);
		addMenuItem(Context,UpDown_Test,createUpDownCtrl(&opt,"RGB(G):",220,5,0,255,true),Invalid,Invalid,NoAction,0);
		addMenuItem(Context,UpDown_Test,createUpDownCtrl(&opt,"RGB(B):",20,5,0,255,true),Invalid,Invalid,NoAction,0);
	}
	
	MenuItem* Radio_Test = addMenuItem(Context,NULL,createMenuContainer(&opt,"WI {^"),RED,SetAlpha(GREEN,0x66),NoAction,0);
	{
		MenuItem *group = createRadioButtonGroup(&opt);
		
		MenuItem* msg = addMenuItem(Context,Radio_Test,createSpacer(&opt,"̃O[v܂AǂւłzuOK"),Invalid,Invalid,NoAction,0);
		
		//Fw肵ėL
		msg->Color.Line = BLACK;
		
		addMenuItem(Context,Radio_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Radio_Test,createSpacer(&opt,"Tv"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,Radio_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Radio_Test,createSpacer(&opt,"PSP̏䐔́H"),WHITE,SetAlpha(BLACK,0x80),NoAction,0);
		addMenuItem(Context,Radio_Test,createRadioButton(&opt,"1",false,group),Invalid,Invalid,NoAction,0);
		addMenuItem(Context,Radio_Test,createRadioButton(&opt,"2",true,group),Invalid,Invalid,NoAction,0);
		addMenuItem(Context,Radio_Test,createRadioButton(&opt,"3",false,group),Invalid,Invalid,NoAction,0);
	}
	
	MenuItem* Specar_Test = addMenuItem(Context,NULL,createMenuContainer(&opt,"Xy[T["),RED,SetAlpha(GREEN,0x66),NoAction,0);
	{
		MenuItem* msg = addMenuItem(Context,Specar_Test,createSpacer(&opt,"Xy[T[͑IsAwȂƉsƂĎg܂"),Invalid,Invalid,NoAction,0);
		msg->Color.Line = BLACK;
		
		addMenuItem(Context,Specar_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Specar_Test,createTriggerButton(&opt,"́@@̂Xy[T[ł^^"),Invalid,Invalid,NoAction,0);
	}
	
	
	MenuItem* Main_Test = addMenuItem(Context,NULL,createMenuContainer(&opt,"ݒςČ"),WHITE,SetAlpha(ORANGE,0x66),NoAction,0);
	{
		MenuItem* Active_Font = addMenuItem(Context,Main_Test,createMenuContainer(&opt,"ANeBu ACe"),RED,SetAlpha(GREEN,0x66),NoAction,0);
		{
			addMenuItem(Context,Active_Font,createSelectBox(&opt,"tHgF:",ColorList,8),Invalid,Invalid,ColorChange,ActiveF);
			AlphaAFA = addMenuItem(Context,Active_Font,createUpDownCtrl(&opt,"At@@:",GetAlpha(Context->Color.Active_Font),2.5,0,255,false),Invalid,Invalid,AlphaChange,ActiveFA);
			
			addMenuItem(Context,Active_Font,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
			
			addMenuItem(Context,Active_Font,createSelectBox(&opt,"wiF@@:",ColorList,2),Invalid,Invalid,ColorChange,ActiveB);
			AlphaABA = addMenuItem(Context,Active_Font,createUpDownCtrl(&opt,"At@@:",GetAlpha(Context->Color.Active_Back),2.5,0,255,false),Invalid,Invalid,AlphaChange,ActiveBA);
		}
		
		MenuItem* Normal_Font = addMenuItem(Context,Main_Test,createMenuContainer(&opt,"ANeBu ACe"),RED,SetAlpha(GREEN,0x66),NoAction,0);
		{
			addMenuItem(Context,Normal_Font,createSelectBox(&opt,"tHgF:",ColorList,20),Invalid,Invalid,ColorChange,NormalF);
			AlphaNFA = addMenuItem(Context,Normal_Font,createUpDownCtrl(&opt,"At@@:",GetAlpha(Context->Color.Normal_Font),2.5,0,255,false),Invalid,Invalid,AlphaChange,NormalFA);
			
			addMenuItem(Context,Normal_Font,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
			
			addMenuItem(Context,Normal_Font,createSelectBox(&opt,"wiF@@:",ColorList,17),Invalid,Invalid,ColorChange,NormalB);
			AlphaNBA = addMenuItem(Context,Normal_Font,createUpDownCtrl(&opt,"At@@:",GetAlpha(Context->Color.Normal_Back),2.5,0,255,false),Invalid,Invalid,AlphaChange,NormalBA);
		}
		
		addMenuItem(Context,Main_Test,createSpacer(&opt,NULL),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Main_Test,createSpacer(&opt,"̑"),Invalid,Invalid,NoAction,0);
		
		addMenuItem(Context,Main_Test,createUpDownCtrl(&opt,"s:",1,1,0,2,true),Invalid,Invalid,LinesChange,0);
		addMenuItem(Context,Main_Test,createSelectBox(&opt,"`: ",TypeList,(Context->MenuInfo.Type?1:0)),Invalid,Invalid,TypeChange,0);
		addMenuItem(Context,Main_Test,createCheckBox(&opt,"ŏ㕔EŃJ[\x83\x5cŔΑ֖߂",true),Invalid,Invalid,ReturnChange,0);
		addMenuItem(Context,Main_Test,createCheckBox(&opt,"j[JɑXbh~",false),Invalid,Invalid,TS_Change,0);
		addMenuItem(Context,Main_Test,createCheckBox(&opt,"wi߁iuhjLɂ",false),Invalid,Invalid,D_Alpha,0);
		addMenuItem(Context,Main_Test,createUpDownCtrl(&opt,"fBC:",500,100,100,2000,true),Invalid,Invalid,DELAYChange,0);
	}
	
	sync_trigger = addMenuItem(Context,NULL,createSpacer(&opt,"gK[{^ɔāÃACe\x95\x5C\x8E\xA6/\x95\x5C\x8E\xA6"),BLACK,PINK,NoAction,0);
	
	//ANeBuACe lݒ
	MenuSetActiveItem( Context ,Select_Test);
}


int threadMain(SceSize args, void *argp)
{
	SceCtrlData pad;
	MenuParams* Params;
	
	SceUInt DELAY = 500;
	
	while( 1 )
	{
		if(
			sceKernelFindModuleByName("sceSystemMemoryManager") && 
			sceKernelFindModuleByName("sceIOFileManager") && 
			sceKernelFindModuleByName("sceGE_Manager") && 
			sceKernelFindModuleByName("sceDisplay_Service") && 
			sceKernelFindModuleByName("sceController_Service") && 
			sceKernelFindModuleByName("sceKernelLibrary")
		)
		{
			break;
		}
		
		sceKernelDelayThread(1000);
	}
	
	//j[\ɑXbh~Lɂ邽
	//vOCÑXbh_vĈSXgĂ
	dumpOtherThreads();
	
	//Q[NɃ𓮓Imۂꍇ
	//ԋpُ̈I邽߂ɓKxȃfBC
	
	//15b炢ҋ@
	sceKernelDelayThread(15000000);
	
	
	//j[쐬
	MenuCreate();
	
	//j[쐬s
	if( !Context || opt.count != ITEM_COUNT ) return sceKernelExitDeleteThread(0);
	
	
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	
	while( 1 )
	{
	   	sceCtrlPeekBufferPositive(&pad, 1);
		
		//Key͂nāAj[̓𒲂ׂiʂ𓾂j
		Params = handleMenu(Context, &pad);
		
		
		if (Params->Item)
		{
			switch (Params->Item->actionID)
			{
				//̃ACeIꂽ
				//Params->Item->actionID 𒲂ׂƕ
				
				//actionID͓ɂ
				//ǂIʂƂ
				//addMenuItem  Data ɂꂼႤlU
				
				case Trigger_Push:
				{
					//ACe̕\/\؂ւɂ
					//Visibile ؂ւ
					sync_trigger->Visible ^= true;
				}
				
				case DELAYChange:
				{
					//Param->Item->CtrľACe^Cvɍ킹
					//ݒlI󋵂𓾂
					
					DELAY = (SceUInt)Params->Item->Ctrl.UD.Now;
				}
				break;
				
				case TS_Change:
				{
					Context->MenuInfo.StopThread = Params->Item->Ctrl.CB_Checked;
				}
				break;
				
				case D_Alpha:
				{
					libmSetBlend( Params->Item->Ctrl.CB_Checked );
				}
				break;
				
				case TypeChange:
				{
					Context->MenuInfo.Type = Params->Item->Ctrl.SB.Index;
				}
				break;
				
				case ColorChange:
				{
					if(Params->Item->Data == ActiveF)
					{
						Context->Color.Active_Font = GetColor(Params->Item->Ctrl.SB.Index);
					}
					else if(Params->Item->Data == ActiveB)
					{
						Context->Color.Active_Back = GetColor(Params->Item->Ctrl.SB.Index);
					}
					else if(Params->Item->Data == NormalF)
					{
						Context->Color.Normal_Font = GetColor(Params->Item->Ctrl.SB.Index);
					}
					else if(Params->Item->Data == NormalB)
					{
						Context->Color.Normal_Back = GetColor(Params->Item->Ctrl.SB.Index);
					}
				}
				break;
				
				case ReturnChange:
				{
					Context->MenuInfo.AutoReturn = Params->Item->Ctrl.CB_Checked;
				}
				break;
				
				case LinesChange:
				{
					Context->MenuInfo.Lines =  (int)Params->Item->Ctrl.UD.Now;
				}
				break;
			}
			
			if(Context->Color.Active_Font != PB_TRANSPARENT)
				Context->Color.Active_Font =  SetAlpha(Context->Color.Active_Font,((int)AlphaAFA->Ctrl.UD.Now));
			
			if(Context->Color.Active_Back != PB_TRANSPARENT)
				Context->Color.Active_Back =  SetAlpha(Context->Color.Active_Back,((int)AlphaABA->Ctrl.UD.Now));
			
			if(Context->Color.Normal_Font != PB_TRANSPARENT)
				Context->Color.Normal_Font =  SetAlpha(Context->Color.Normal_Font,((int)AlphaNFA->Ctrl.UD.Now));
			
			if(Context->Color.Normal_Back != PB_TRANSPARENT)
				Context->Color.Normal_Back =  SetAlpha(Context->Color.Normal_Back,((int)AlphaNBA->Ctrl.UD.Now));
		}
		
		if( getThreadsStat() == MENU_SUSPEND )
		{
			//Xbh~Ăꍇ̃j[`
			
			clearMenuBuffers();
			renderMenu(Context,20,20);
			swapMenuBuffers( PSP_DISPLAY_SETBUF_IMMEDIATE );
		}
		else if( setMenuBuffers(PSP_DISPLAY_SETBUF_NEXTFRAME) )
		{
			//ʏ̃j[`
			
			renderMenu(Context,22,20);
			
			if( isMenuOpen(Context) )
			{
				libmPrint(0,264,SetAlpha(WHITE,0xFF),SetAlpha(BLACK,0xFF),"~=IA=߂");
			}
			
			sceDisplayWaitVblankStart();
		}
		
		sceKernelDelayThread( 1000 );
	}
	
	return sceKernelExitDeleteThread( 0 );
}



int module_start(SceSize args, void *argp)
{
    SceUID main_thid = sceKernelCreateThread("MenuTest_Main", threadMain, 16,0x900, 0, NULL);
	
    if(main_thid >= 0) sceKernelStartThread(main_thid, args, argp);
	
    return 0;
}

int module_stop(SceSize args, void *argp)
{
    return 0;
}
